﻿--
-- Ford 8340 Gearbox
--
-- author  Mythos
-- date  23/01/2012
-- www.Virtual-Farmers.gr
-- Copyright (C) ARM Team, All Rights Reserved.

F8340gbox = {};
--________________________________________________________________________________________________________________________________________________________
function F8340gbox.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:load(xmlFile)

	self.gbEvent= SpecializationUtil.callSpecializationsFunction("gbEvent");
	
	self.backRatioBackup = tonumber(getXMLString(xmlFile, "vehicle.motor#backwardGearRatio"));
	
	self.gearHandle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.gearHandle#index"));
	self.sfHandle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.sfHandle#index"));
	self.shuttleHandle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.shuttleHandle#index"));
	self.throttleHandle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.throttleHandle#index"));
	
	self.slowDash = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.slowDash#index"));
	self.fastDash = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fastDash#index"));
		
	self.gearLayers = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.gears.gear(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "#index"));
		if node == nil then
			break;
		end;
        self.gearLayers[i+1] = node;
		i = i +1;
    end;
	
	self.slowGears = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.gears.gear(%d)", i);
		local node = tonumber(getXMLString(xmlFile, key.. "#slowRatio"));
		if node == nil then
			break;
		end;
        self.slowGears[i+1] = node;
		i = i +1;		
    end;
	
	self.quickGears = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.gears.gear(%d)", i);
		local node = tonumber(getXMLString(xmlFile, key.. "#quickRatio"));
		if node == nil then
			break;
		end;
        self.quickGears[i+1] = node;
		i = i +1;
    end;
	
	self.FHH = Overlay:new("FHH", Utils.getFilename("textures/Hud.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	
	self.FHH1 = Overlay:new("FHH1", Utils.getFilename("textures/Hud1.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH2 = Overlay:new("FHH2", Utils.getFilename("textures/Hud2.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH3 = Overlay:new("FHH3", Utils.getFilename("textures/Hud3.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH4 = Overlay:new("FHH4", Utils.getFilename("textures/Hud4.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	
	self.FHH5 = Overlay:new("FHH5", Utils.getFilename("textures/Hud5.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH6 = Overlay:new("FHH6", Utils.getFilename("textures/Hud6.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH7 = Overlay:new("FHH7", Utils.getFilename("textures/Hud7.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHH8 = Overlay:new("FHH8", Utils.getFilename("textures/Hud8.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	
	self.FHHcon = Overlay:new("FHHcon", Utils.getFilename("textures/Hudcon.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHHcoff = Overlay:new("FHHcoff", Utils.getFilename("textures/Hudcoff.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	
	self.FHHslow = Overlay:new("FHHslow", Utils.getFilename("textures/Hudslow.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	self.FHHfast = Overlay:new("FHHfast", Utils.getFilename("textures/Hudfast.png", self.baseDirectory), 0.7543, 0.1715, 0.237, 0.237);
	
	self.ct = 2000;
	self.sl = 0;
	self.Facc = 0;
	self.clutch = false;
	self.slow = false;
	self.clutchWarning = false;
	self.powerWarning = false;
	self.gearGroup = 0;
	self.fhud = false;

end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:delete()

end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:mouseEvent(posX, posY, isDown, isUp, button)

end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:keyEvent(unicode, sym, modifier, isDown)

end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:update(dt)
	if self:getIsActiveForInput() and self:getIsActive() and self.fg then
		
		if InputBinding.hasEvent(InputBinding.F_HUD) then
			self.fhud = not self.fhud;
		end;
		
		if InputBinding.hasEvent(InputBinding.F_GEAR_UP) and not self.clutch then
			if self.sl >= 1 and self.sl <8 then
				if self.sl ==4 and self.gearGroup~=2 then
					self.clutchWarning = true;
				elseif self.sl ==4 and self.gearGroup==2 then
					self:gbEvent(9);
				else
					self:gbEvent(9);
				end;
			end;
			if self.sl ==0 then
				self.clutchWarning = true;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.F_GEAR_DOWN) and not self.clutch then
			if self.sl >1 and self.sl <= 8 then
				if self.sl ==5 and self.gearGroup~=1 then
					self.clutchWarning = true;
				elseif self.sl ==5 and self.gearGroup==1 then
					self:gbEvent(10);
				else
					self:gbEvent(10);
				end;
			end;
			if self.sl ==0 then
				self.clutchWarning = true;
			end;
		end;
		
		if self.clutch and InputBinding.hasEvent(InputBinding.F_GEAR_UP) then
			self:gbEvent(6);
		end;
		if self.clutch and InputBinding.hasEvent(InputBinding.F_GEAR_DOWN) then
			self:gbEvent(7);
		end;
		if InputBinding.hasEvent(InputBinding.F_GEAR_NEUTRAL) then
			if self.clutch then
				self:gbEvent(8);
			else
				self.clutchWarning = true;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.F_CLUTCH) then
			self:gbEvent(11, true);
		else
			self:gbEvent(11, false);
		end;
		
		if InputBinding.hasEvent(InputBinding.F_POWER) then
			if self.clutch then
				self.slow = not self.slow;
			else
				self.powerWarning = true;
			end;
			if self.slow then
				self:gbEvent(5, true);
			else
				self:gbEvent(5, false);
			end;
		end;
		
		if self.ignitionKey then
			if self.slow then
				self:gbEvent(2);
			else
				self:gbEvent(3);
			end;
		else
			self:gbEvent(4);
		end;
		
		
		
		if self.clutchWarning then
			self.ct = self.ct - dt;
			if self.ct <0 then
				self.clutchWarning = false;
				self.ct = 2000;
			end;
		end;
		if self.powerWarning then
			self.ct = self.ct - dt;
			if self.ct <0 then
				self.powerWarning = false;
				self.ct = 2000;
			end;
		end;
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:updateTick(dt)
	
	if self:getIsActive() and self.fg then
		self.motor:setSpeedLevel(0, true)
		
		if not self.clutch then
			if self.sl ==0 then
				self.Facc = 0;
			elseif self.sl ==1 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==2 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==3 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==4 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==5 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==6 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==7 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			elseif self.sl ==8 then
				if self.slow then
					self.Facc = self.slowGears[self.sl];
				else
					self.Facc = self.quickGears[self.sl];
				end;
			end;
		end;
		self:gbEvent(1);
		
	end;
	
	if not self.isAITractorActivated and self.fg then
		if self.isEntered then
			self:gbEvent(12, nil, self.Facc);
		end;
	else
		self.motor.backwardGearRatio = 9;
		self.motor.forwardGearRatios = {11/2, 11/1.5, 11, 11/1.5};
	end;
 
 end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:gbEvent(mode, state, ratio, noEventSend)
	F8340gboxEvent.sendEvent(self, mode, state, ratio, noEventSend);
	
	if mode == 1 then
		for i=1,8 do
			setVisibility(self.gearLayers[i], false);
		end;
		setVisibility(self.gearLayers[self.sl], true);
	elseif mode == 2 then
		setVisibility(self.slowDash, true);
		setVisibility(self.fastDash, false);
	elseif mode == 3 then
		setVisibility(self.slowDash, false);
		setVisibility(self.fastDash, true);
	elseif mode == 4 then
		setVisibility(self.slowDash, false);
		setVisibility(self.fastDash, false);
	elseif mode == 5 then
		if state then
			self.slow = true;
			setRotation(self.sfHandle, math.rad(-25), 0, 0);
		else
			self.slow = false;
			setRotation(self.sfHandle, math.rad(25), 0, 0);
		end;
	elseif mode == 6 then
		if self.gearGroup~=2 then
			self.gearGroup =2;
			self.sl = 5;
			setRotation(self.gearHandle, math.rad(25), 0, 0);
		end;
	elseif mode == 7 then
		if self.gearGroup==2 then
			self.sl = 4;
		elseif self.gearGroup==0 then
			self.sl = 1;
		end;
		self.gearGroup = 1;
		setRotation(self.gearHandle, math.rad(-25), 0, 0);
	elseif mode == 8 then
		self.gearGroup = 0;
		self.sl = 0;
		setRotation(self.gearHandle, 0, 0, 0);
	elseif mode == 9 then
		self.sl = self.sl +1;
	elseif mode == 10 then
		self.sl = self.sl -1;
	elseif mode == 11 then
		if state then
			self.clutch = true;
			self.Facc = 0;
		else
			self.clutch = false;
		end;
	elseif mode == 12 then
		if ratio ==0 then
			self.motor.backwardGearRatio = 0;
			self.motor.forwardGearRatios = {0,0,0};
		else
			self.motor.backwardGearRatio = self.backRatioBackup;
			self.motor.forwardGearRatios = {ratio/2,ratio/1.5,ratio};
		end;
	end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:readStream(streamId, connection)
	self.sl = streamReadInt32(streamId);
	self.Facc = streamReadFloat32(streamId);
	self.gearGroup = streamReadInt32(streamId);
	self.slow = streamReadBool(streamId);
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:writeStream(streamId, connection)
	streamWriteInt32(streamId, self.sl);
	streamWriteFloat32(streamId, self.Facc);
	streamWriteInt32(streamId, self.gearGroup);
	streamWriteBool(streamId, self.slow);
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		self.sl = Utils.getNoNil(getXMLInt(xmlFile, key.."#sl"),0);
		self.gearGroup = Utils.getNoNil(getXMLInt(xmlFile, key.."#gearGroup"),0);
		self.slow = Utils.getNoNil(getXMLBool(xmlFile, key.."#slow"),false);
		self.fhud = Utils.getNoNil(getXMLBool(xmlFile, key.."#fhud"),false);
		self:gbEvent(5, self.slow);
		self:gbEvent(1, false);
		self:gbEvent(1, true);
		if self.gearGroup ==0 then
			self:gbEvent(8);
		elseif self.gearGroup ==1 then
			self:gbEvent(7);
		elseif self.gearGroup ==2 then
			self:gbEvent(6);
		end;
		if self.ignitionKey then
			if self.slow then
				self:gbEvent(2);
			else
				self:gbEvent(3);
			end;
		else
			self:gbEvent(4);
		end;

	end;
	
	return BaseMission.VEHICLE_LOAD_OK;
end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'sl="'..tostring(self.sl)..
	'" gearGroup="'..tostring(self.gearGroup)..
	'" fhud="'..tostring(self.fhud)..
	'" slow="'..tostring(self.slow)..'"';
	local nodes = nil;
	
	return attributes,nodes;
end;
--________________________________________________________________________________________________________________________________________________________
function F8340gbox:draw()

if self.fg then
	
	if self.clutchWarning then
		g_currentMission:addWarning("Press the clutch to change the gearbox group", 0.07+0.022);
	end;
	if self.powerWarning then
		g_currentMission:addWarning("Press the clutch to change the gearbox level", 0.07+0.022);
	end;
	
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("FHHUD"), self.typeDesc), InputBinding.F_HUD);
	
	if self.fhud then
		self.FHH:render();
		if self.clutch then
			self.FHHcon:render();
		else
			self.FHHcoff:render();
		end;
		if self.slow then
			self.FHHslow:render();
		else
			self.FHHfast:render();
		end;
		if self.sl ==1 then
			self.FHH1:render();
		elseif self.sl ==2 then
			self.FHH2:render();
		elseif self.sl ==3 then
			self.FHH3:render();
		elseif self.sl ==4 then
			self.FHH4:render();
		elseif self.sl ==5 then
			self.FHH5:render();
		elseif self.sl ==6 then
			self.FHH6:render();
		elseif self.sl ==7 then
			self.FHH7:render();
		elseif self.sl ==8 then
			self.FHH8:render();
		end;
	end;

end;

end;

--________________________________________________________________________________________________________________________________________________________
function F8340gbox:onLeave()
end;