﻿F8340gboxEvent = {};
F8340gboxEvent_mt = Class(F8340gboxEvent, Event);

InitEventClass(F8340gboxEvent, "F8340gboxEvent");

function F8340gboxEvent:emptyNew()
    local self = Event:new(F8340gboxEvent_mt);
    self.className="F8340gboxEvent";
    return self;
end;

function F8340gboxEvent:new(vehicle, mode, state, ratio)
    local self = F8340gboxEvent:emptyNew()
    self.vehicle = vehicle;
	self.mode = mode;
	self.state = state;
	self.fgRatio = ratio;
    return self;
end;

function F8340gboxEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.mode = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
	self.fgRatio = streamReadFloat32(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function F8340gboxEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, self.mode);
	streamWriteBool(streamId, self.state);
	streamWriteFloat32(streamId, self.fgRatio);
end;

function F8340gboxEvent:run(connection)
	self.vehicle:gbEvent(self.mode, self.state, self.fgRatio, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(F8340gboxEvent:new(self.vehicle, self.mode, self.state, self.fgRatio), nil, connection, self.vehicle);
    end;
end;

function F8340gboxEvent.sendEvent(vehicle, mode, state, ratio, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(F8340gboxEvent:new(vehicle, mode, state, ratio), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(F8340gboxEvent:new(vehicle, mode, state, ratio));
		end;
	end;
end;